;================================
;          ZX-Assembler-2 
;      by Artic Computing LTD
;================================
;         Color Loader
;        by Paul Farrow
;================================

ORG 4084

@Loader
	LD BC,7FEF 		;Chroma test
	IN A,(C) 		;Hello Chroma!
	BIT 5,A 		;Chroma answered?
	RET NZ 			;No, return
	LD HL,C000 		;Start of color attributes table
	LD D,H 			;Set all values to 0
	LD E,01 
	LD BC,03FF 
	LD (HL),L 
	LDIR 
	LD HL,Colors 		;User defined color table
@Loader1
	LD A,(HL) 		;Get chr code
	BIT 7,A 		;End of table?
	JR NZ Mode		;Yes, set mode
	INC HL 			;Get chr count
	LD D,18 		;Locate chr position in attribute table
	ADD A,A 
	RL D 
	ADD A,A 
	RL D 
	ADD A,A 
	RL D 
	LD E,A 
	LD A,(HL) 		;Set chr count
	INC HL 
@Loader2
	PUSH HL 		;PUSH table pointer
	LD C,08 		;Byte count
	LDIR 			;Copy data to attribute table
	POP HL 			;POP table pointer
	DEC A 			;Decrease chr counter
	JR NZ Loader2		;Loop until A=0
	LD C,08 		;Offset
	ADD HL,BC 		;Next position in table
	JR Loader1		;Loop until end of color table reached
@Mode
	SUB 60			;0110 0000 Character code mode+black border 
	LD BC,7FEF 
	OUT (C),A 
	IN A,FE
	RET
;================================
; Color table
;
; Format...
;
;  Chr Code/Count/Attribute (8 Bytes)
;================================
@Colors

00 80 0C 0C 0C 0C 0C 0C 0C 0C	;Defaults color, Bright Green Ink/Black Paper
01 01 77 77 77 77 77 77 77 77   ;Grey
02 01 66 66 66 66 66 66 66 66 	;Yellow
03 01 55 55 55 55 55 55 55 55 	;Cyan
04 01 44 44 44 44 44 44 44 44 	;Green
05 01 33 33 33 33 33 33 33 33 	;Magenta
06 01 22 22 22 22 22 22 22 22 	;Red
07 01 11 11 11 11 11 11 11 11 	;Blue
08 01 00 00 00 00 00 00 00 00 	;Black
41 01 FF FF FF FF FF FF FF FF 	;White
42 01 EE EE EE EE EE EE EE EE 	;Bright Yellow
43 01 DD DD DD DD DD DD DD DD 	;Bright Cyan 
44 01 CC CC CC CC CC CC CC CC  	;Bright Green
45 01 BB BB BB BB BB BB BB BB  	;Bright Magent
46 01 AA AA AA AA AA AA AA AA  	;Bright Red
47 01 99 99 99 99 99 99 99 99  	;Bright Blue
48 01 88 88 88 88 88 88 88 88 	;Bright Black
80 				;End of Table
;================================
; Reset colors
;================================
@Reset
	LD HL,C000		;Start of attribute table
	LD (HL),F0		;Black Ink/White Paper
	LD D,H
	LD E,L
	INC DE			;Set destination
	LD BC,+1023		;Byte count
	LDIR			;Fill attribute table with F0
	LD A,6F			;White border
	JP Mode+2